﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Demo
{
	/// <summary>
	/// Provides random data for some of the charts.
	/// </summary>
	public class DataProvider
	{
		public DataProvider(double min, double max)
		{
			_r = new Random(DateTime.Now.Second);

			_min = min;
			_max = max;
			_prev = (min + max) / 2;
		}

		public double Get()
		{
			return Get(double.NaN);
		}

		public double Get(double ampl)
		{
			double res = _r.NextDouble();

			res *= (_max - _min);
			res += _min;

			if (ampl != double.NaN)
			{
				if (Math.Abs(res - _prev) > ampl)
				{
					if (res > _prev)
					{
						res = _prev + ampl;
						if (res > _max)
							res = _max;
					}
					else
					{
						res = _prev - ampl;
						if (res < _min)
							res = _min;
					}
				}
			}

			_prev = res;
			return res;
		}

		private Random _r;

		private double _min;
		private double _max;

		private double _prev;
	}
}
