﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Effects;

namespace Demo
{
	/// <summary>
	/// Interaction logic for DataTimeValues.xaml
	/// </summary>
	public partial class DataTimeValues : UserControl
	{
		public DataTimeValues()
		{
			InitializeComponent();

            lineChart1.BeginInit();

            DropShadowEffect effect = new DropShadowEffect() { Opacity = 0.3, ShadowDepth = 3, };

			lineChart1.Series.Clear();
			DateTime start = DateTime.MinValue;
			DateTime end = DateTime.MinValue;
            BrushCollection fills = Utilities.GetGradientFills();
            BrushCollection strokes = Utilities.GetGradientStrokes();


			//Series1
            LineSeries series1 = new LineSeries()
            {
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),
                ScatterFills = new BrushCollection(),
                ScatterStrokes = new BrushCollection(),
            };
            series1.Effect = effect;
            lineChart1.LineType = LineType.Area2DStack;
			series1.Strokes.Add(strokes[3]);
            series1.Fills.Add(Window1.TransformBrush(fills[3], 255));		
			series1.ScatterType = ScatterType.Diamond;
			series1.ScatterSize = 15;
            series1.ScatterFills.Add(Window1.TransformBrush(fills[3], 255));
			series1.ScatterStrokes.Add(strokes[3]);
            series1.YData = new DoubleCollection() { 228, 213, 34, 56, 109, 40, 69, 38, 48, 111, 95, 73 };
            //series1.Y2Data = new DoubleCollection() { 128, 113, 134, 156, 45, 109, 88, 54, 57, 81, 142, 123 };
			for (int i = 0; i < 12; i++)
			{
				DateTime d = new DateTime(2012, i + 1, 1);
				series1.XData.Add(d.ToOADate());
				if (i == 0)
					start = d;
				if (i == 11)
					end = d;
			}		
			lineChart1.Series.Add(series1);



			//Series2
            LineSeries series2 = new LineSeries() 
            {
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),
                ScatterFills = new BrushCollection(),
                ScatterStrokes = new BrushCollection(),
            };
            series2.Effect = effect;
            lineChart1.LineType = LineType.Area2DStack;
			series2.Strokes.Add(strokes[2]);
            series2.Fills.Add(Window1.TransformBrush(fills[2], 255));		
			series2.ScatterType = ScatterType.Triangle;
			series2.ScatterSize = 15;
            series2.ScatterFills.Add(Window1.TransformBrush(fills[2], 255));
			series2.ScatterStrokes.Add(strokes[2]);
            series2.YData = new DoubleCollection() { 128, 113, 134, 156, 45, 109, 88, 54, 57, 81, 142, 123 };
            //series2.Y2Data = new DoubleCollection() { 128, 113, 134, 156, 45, 109, 88, 54, 57, 81, 142, 123 };
			for (int i = 0; i < 12; i++)
			{
				DateTime d = new DateTime(2012, i + 1, 1);
				series2.XData.Add(d.ToOADate());
			}
			lineChart1.Series.Add(series2);



			//XAxisSettings
			lineChart1.XAxes[0].ValueFormat = ValueFormat.DateTime;
            lineChart1.XAxes[0].MinValue = start.ToOADate();
            lineChart1.XAxes[0].MaxValue = end.ToOADate();
            lineChart1.XAxes[0].LabelFormat = "MMMM dd";
            lineChart1.XAxes[0].LabelType = LabelType.AutoScale;
            lineChart1.XAxes[0].Interval = (end.ToOADate() - start.ToOADate()) / 8;
            lineChart1.XAxes[0].LabelRotationAngle = 35;
            lineChart1.XAxes[0].Title = "";
            lineChart1.XAxes[0].Tick = 5;
            lineChart1.XAxes[0].Title = "2011";
			//lineChart1.XAxisSettings.LabelStroke = Brushes.Green;
			//lineChart1.XAxisSettings.TitleStroke = Brushes.Green;

			//YAxisSettings
            lineChart1.YAxes[0].Title = "(inches)";		


			//Y2AxisSettings
            lineChart1.Y2Axes.Add(new Axis());
            lineChart1.Y2Axes[0].Title = "(centimeters)";
			
			List<string> list = new List<string>();
			for (int i = 0; i < 20; i++)
				list.Add(((i * 20) * 2.54).ToString("0.00"));
			lineChart1.Y2Axes[0].Labels = list;
            lineChart1.Y2Axes[0].LabelType = LabelType.CustomText;
            lineChart1.Y2Axes[0].CustomLabelPosition = CustomLabelPosition.AutoScalePoints;
            lineChart1.Y2Axes[0].MaxValue = 360;
            lineChart1.Y2Axes[0].MinValue = 0;
            lineChart1.Y2Axes[0].Interval = 20;
            

			lineChart1.Title = "Monthly rainfall and averages";
			lineChart1.TitleFontSize = 18;

            lineChart1.GridFills.Add(Brushes.Transparent);
            lineChart1.XAxes[0].LabelStroke = Brushes.White;
            lineChart1.YAxes[0].LabelStroke = Brushes.White;
            lineChart1.XAxes[0].TitleStroke = Brushes.White;
            lineChart1.YAxes[0].TitleStroke = Brushes.White;
            //lineChart1.YAxisSettings.LabelFormat = "0.##";
            lineChart1.YAxes[0].LabelOffset = 10;
            //lineChart1.XAxisSettings.LabelFormat = "0.##";
            lineChart1.YAxes[0].TitleOffset = 10;
            lineChart1.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;
            lineChart1.YAxes[0].HorLabelAlignment = HorizontalAlignment.Left;
            lineChart1.XAxes[0].VertLabelAlignment = VerticalAlignment.Bottom;
            lineChart1.XAxes[0].HorLabelAlignment = HorizontalAlignment.Center;

            lineChart1.Y2Axes[0].LabelStroke = Brushes.White;
            lineChart1.Y2Axes[0].LabelOffset = 10;
            lineChart1.Y2Axes[0].TitleStroke = Brushes.White;
            lineChart1.Foreground = Brushes.White;

            lineChart1.Y2Axes[0].VertLabelAlignment = VerticalAlignment.Center;


            ////probi
            //lineChart1.GridStrokeThickness = 10;
            //lineChart1.XAxisSettings.StrokeThickness = 10;
            //lineChart1.X2AxisSettings.StrokeThickness = 10;
            //lineChart1.X2AxisSettings.Stroke = Brushes.Black;
            //lineChart1.X2AxisSettings.Tick = 5;
            //lineChart1.X2Labels = list;
            //lineChart1.YAxisSettings.StrokeThickness = 10;
            //lineChart1.YAxisSettings.Tick = 5;
            //lineChart1.Y2AxisSettings.Tick = 5;
            //lineChart1.Y2AxisSettings.StrokeThickness = 10;
            //lineChart1.Series[0].StrokeThickness = 10;
            //(lineChart1.Series[0] as LineSeries).LineType = LineType.None;
            //(lineChart1.Series[1] as LineSeries).LineType = LineType.None;
            //series1.X2Data = new DoubleCollection() { 1, 2, 3, 4, 5, 6, 7, 8 };
            lineChart1.EndInit();
		}

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }
	}
}
