﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Effects;

namespace Demo
{
	/// <summary>
	/// Interaction logic for Grid.xaml
	/// </summary>
	public partial class Grid : UserControl
	{
		public Grid()
		{
			InitializeComponent();

			lineChart.TitleVisibility = Visibility.Collapsed;
            

			//XAxisSettings
			lineChart.XAxes[0].LabelType = LabelType.AutoScale;
            lineChart.XAxes[0].Title = "";
            lineChart.XAxes[0].LabelOffset = 20;
            lineChart.XAxes[0].MinValue = 0;
            lineChart.XAxes[0].MaxValue = 100;
            lineChart.XAxes[0].Interval = 20;
            lineChart.XAxes[0].HorLabelAlignment = HorizontalAlignment.Center;
            lineChart.XAxes[0].LabelStroke = Brushes.White;

			//YAxisSettings
            lineChart.YAxes[0].LabelType = LabelType.AutoScale;
            lineChart.YAxes[0].Title = "";
            lineChart.YAxes[0].LabelOffset = 20;
            lineChart.YAxes[0].MinValue = 0;
            lineChart.YAxes[0].MaxValue = 100;
            lineChart.YAxes[0].Interval = 20;
            lineChart.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;
            lineChart.YAxes[0].LabelStroke = Brushes.White;


            LineSeries series = new LineSeries()
            {
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),
                ScatterFills = new BrushCollection(),
                ScatterStrokes = new BrushCollection(),
            };
            series.Effect = new DropShadowEffect() { Opacity = 0.3, ShadowDepth = 3, };
			series.YData = new DoubleCollection() {
				82, 60, 91, 73, 13, 62, 33, 38, 47, 59, 22,
			};
			series.XData = new DoubleCollection() {
				0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100,
			};

			//series.Fills.Add(Brushes.Red);
			series.Strokes.Add(Utilities.GetGradientStrokes()[3]);
			series.StrokeThickness = 3;
            series.ScatterFills.Add(Window1.TransformBrush(Utilities.GetGradientFills()[3], 255));
			series.ScatterStrokes.Add(Utilities.GetGradientStrokes()[3]);
			series.ScatterType = ScatterType.Circle;
			series.ScatterSize = 20;
			lineChart.Series.Clear();
			lineChart.Series.Add(series);

            lineChart.GridFills = new List<Brush>();
            lineChart.GridFills.Add(new SolidColorBrush(Color.FromArgb(100, 200, 200, 200)));
            lineChart.GridFills.Add(new SolidColorBrush(Color.FromArgb(100, 230, 230, 230)));

			gridType.SelectedIndex = 1;
            intervalSliderY.Value = lineChart.YAxes[0].Interval;
            intervalSliderX.Value = lineChart.XAxes[0].Interval;			
		}

		private void intervalSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			if (lineChart != null)
			{
				if ((sender as Slider).Name == "intervalSliderY")
                    lineChart.YAxes[0].Interval = intervalSliderY.Value;
				else
                    lineChart.XAxes[0].Interval = intervalSliderX.Value;
			}
		}

		private void gridType_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			if (gridType.SelectedIndex == 0)
				lineChart.GridType = GridType.Crossed;
			if (gridType.SelectedIndex == 1)
				lineChart.GridType = GridType.Horizontal;			
			if (gridType.SelectedIndex == 2)
				lineChart.GridType = GridType.Vertical;
		}

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }

        private void ComboBox_DropDownOpened(object sender, EventArgs e)
        {
            ((sender as ComboBox).Items[0] as ComboBoxItem).Visibility = Visibility.Collapsed;
        }

        private void ComboBox_DropDownClosed(object sender, EventArgs e)
        {
            ((sender as ComboBox).Items[0] as ComboBoxItem).Visibility = Visibility.Visible;
        }
	}
}
