﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Collections;
using System.Windows.Media.Effects;

namespace Demo
{
	/// <summary>
	/// Interaction logic for MouseDrag.xaml
	/// </summary>
	public partial class MouseDrag : UserControl
	{
		private DoubleCollection xDataBar;
		private DoubleCollection yDataBar;
		private List<string> labelsBar;

		
		private DoubleCollection xDataLine0;
		private DoubleCollection yDataLine0;
	    private DoubleCollection xDataLine1;
		private DoubleCollection yDataLine1;

		private List<string> labelsLine;

		//private List<Brush> fills;
		//private List<Brush> strokes;


		public MouseDrag()
		{
			InitializeComponent();
            BrushCollection fills = Utilities.GetGradientFills();
            BrushCollection strokes = Utilities.GetGradientStrokes();

			xDataBar = new DoubleCollection() {
				20, 40, 60, 80, 100, 120,
			};
			yDataBar = new DoubleCollection() {
				72, -60, 73, 59, -58, 63,
			};
			labelsBar = new List<string>(new string[] {
				"March", "April", "May", "June", "July", "August",
			});
			labelsLine = new List<string>(new string[] {
				"Jan", "Feb","Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
			});
            xDataLine0 = new DoubleCollection();
            yDataLine0 = new DoubleCollection();
            xDataLine1 = new DoubleCollection();
            yDataLine1 = new DoubleCollection();




			//Bar Chart
			barChart.TitleVisibility = Visibility.Collapsed;
			barChart.YAxes[0].Title = "";
			barChart.XAxes[0].Title = "";

            BarSeries series = new BarSeries()
            {
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),               
            };
            series.Effect = new DropShadowEffect() { Opacity = 0.3, ShadowDepth = 3, };

            BrushCollection brushes = fills;
            for (int i = 0; i < 8; i++)
            {
                LinearGradientBrush b = brushes[i] as LinearGradientBrush;
                Color light = b.GradientStops[0].Color;
                Color dark = b.GradientStops[1].Color;
                VisualBrush brush = Utilities.CreateVisualBrush(
                    dark, light, new SolidColorBrush(dark), 4, Orientation.Vertical, 4);
                series.Fills.Add(brush);
            }
			//series.Fills = fills;
			//series.Strokes = strokes;
            series.StrokeThickness = 0;
			barChart.Series.Clear();
			barChart.Series.Add(series);
            barChart.YAxes[0].LabelStroke = Brushes.White;
            barChart.XAxes[0].LabelStroke = Brushes.White;
            barChart.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;
            //barChart.GridFills.Add(Brushes.Transparent);
            barChart.XAxes[0].HorLabelAlignment = HorizontalAlignment.Center;

			//Line Chart			
			lineChart.TitleVisibility = Visibility.Collapsed;
            lineChart.YAxes[0].Title = "";
			lineChart.XAxes[0].Title = "";
            lineChart.LineType = LineType.Area2D;

			Random r = new Random();
			lineChart.Series.Clear();
			for (int i = 0; i < 2; i++)
			{
				for (int j = 0; j < 12; j++)
				{
					double ampl = r.NextDouble() * 4 + 0.1;
					if (r.Next(1, 3) == 1)
						ampl = r.NextDouble() * 25 + 0.1; // Jump
					ampl += (1 - i) * 5 + 5;

					if (i == 0)
					{
						yDataLine0.Add(ampl);
						xDataLine0.Add(j);
					}
					else
					{
						yDataLine1.Add(ampl);
						xDataLine1.Add(j);
					}
				}
			}

			LineSeries lineSeries0 = new LineSeries()
            {                
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),
                ScatterStrokes = new BrushCollection(),
                ScatterFills = new BrushCollection(),
            };
            lineSeries0.Effect = new DropShadowEffect() { Opacity = 0.3, ShadowDepth = 3, };
            lineSeries0.Strokes.Add(new SolidColorBrush((fills[0] as LinearGradientBrush).GradientStops[1].Color));
            lineSeries0.Fills.Add(Window1.TransformBrush(fills[0], 255));
			lineSeries0.ScatterFills.Add(Window1.TransformBrush(fills[0],255));
            lineSeries0.ScatterStrokes.Add(strokes[0]);			
			lineSeries0.ScatterType = ScatterType.Square;
			lineSeries0.XData = xDataLine0;
			lineSeries0.YData = yDataLine0;
            lineSeries0.ScatterSize = 15;
            lineSeries0.StrokeThickness = 4;
			lineChart.Series.Add(lineSeries0);

            LineSeries lineSeries1 = new LineSeries()
            {
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),
                ScatterStrokes = new BrushCollection(),
                ScatterFills = new BrushCollection(),
            };
            lineSeries1.Effect = new DropShadowEffect() { Opacity = 0.5, ShadowDepth = 3, };
            lineSeries1.Strokes.Add(new SolidColorBrush((fills[1] as LinearGradientBrush).GradientStops[1].Color));
            lineSeries1.Fills.Add(Window1.TransformBrush(fills[1], 255));
			lineSeries1.ScatterFills.Add(Window1.TransformBrush(fills[1],255));
            lineSeries1.ScatterStrokes.Add(strokes[1]);
			lineSeries1.ScatterType = ScatterType.Square;
			lineSeries1.XData = xDataLine1;
			lineSeries1.YData = yDataLine1;
            lineSeries1.ScatterSize = 15;
            lineSeries1.StrokeThickness = 4;
			lineChart.Series.Add(lineSeries1);

            lineChart.YAxes[0].LabelStroke = Brushes.White;
            lineChart.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;
            //lineChart.GridFills.Add(Brushes.Transparent);
			comboBox.SelectedIndex = 0;


            VisualBrush fb1 = Utilities.CreateVisualBrush(
                Colors.Gray, Colors.White, new SolidColorBrush(Colors.Gray), 0, Orientation.Horizontal, 0);
            fb1.Opacity = 0.2;

            lineChart.GridFills.Add(fb1);
            barChart.GridFills.Add(fb1);
		}

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            barChart.ShowCrosshair = true;
            lineChart.ShowCrosshair = true;

            InvalidateMeasure();
            InvalidateArrange();
            UpdateLayout();

            barChart.ShowCrosshair = false;
            lineChart.ShowCrosshair = false;

            InvalidateMeasure();
            InvalidateArrange();
            UpdateLayout();
        }

		private void comboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			BarSeries series = barChart.Series[0] as BarSeries;					

			if (comboBox.SelectedIndex == 0)
			{
				foreach (Brush b in series.Fills)
				{
					if (b is LinearGradientBrush)
					{
						LinearGradientBrush linear = b as LinearGradientBrush;
						linear.StartPoint = new Point(0, 0);
						linear.EndPoint = new Point(1, 0);
					}
				}

				barChart.GridType = GridType.Horizontal;
				barChart.Behavior = Behavior.AllowYDrag;
				barChart.YAxes[0].Labels = new List<string>();
				barChart.XAxes[0].Labels = labelsBar;
				barChart.YAxes[0].LabelType = LabelType.AutoScale;
				barChart.XAxes[0].LabelType = LabelType.CustomText;



				barChart.BarType = BarType.Vertical;
				series.XData = xDataBar;
				series.YData = yDataBar;

                barChart.YAxes[0].MaxValue = double.NaN;
                barChart.YAxes[0].MinValue = double.NaN;

                barChart.XAxes[0].MaxValue = double.NaN;
                barChart.XAxes[0].MinValue = double.NaN;


                barChart.YAxes[0].Interval = 20;
                barChart.XAxes[0].MinValue = 0;
                barChart.XAxes[0].MaxValue = 120;
                barChart.XAxes[0].Interval = 20;
                barChart.PlotAreaStrokeThickness = new Thickness(2, 0, 0, 0);


				//LineChart
				lineChart.GridType = GridType.Horizontal;
                lineChart.Behavior = Behavior.AllowXDrag | Behavior.AllowYDrag;
				lineChart.XAxes[0].LabelType = LabelType.Empty;
				//lineChart.XAxisSettings.LabelRotationAngle = 90;
				//lineChart.XLabels = labelsLine;		
				lineChart.XAxes[0].Interval = 1;

				lineChart.YAxes[0].LabelType = LabelType.AutoScale;
				lineChart.YAxes[0].Labels = new List<string>();

                lineChart.YAxes[0].Interval = 10;		
			}
			else if (comboBox.SelectedIndex == 1)
			{
				foreach (Brush b in series.Fills)
				{
					if (b is LinearGradientBrush)
					{
						LinearGradientBrush linear = b as LinearGradientBrush;
						linear.StartPoint = new Point(0, 0);
						linear.EndPoint = new Point(0, 1);
					}
				}

				barChart.GridType = GridType.Vertical;
				barChart.Behavior = Behavior.AllowXDrag;
				barChart.XAxes[0].Labels = new List<string>();
				barChart.YAxes[0].Labels = labelsBar;
				barChart.YAxes[0].LabelType = LabelType.CustomText;
                barChart.XAxes[0].LabelType = LabelType.AutoScale;

                barChart.BarType = BarType.Horizontal;
				series.XData = yDataBar;
				series.YData = xDataBar;

                barChart.XAxes[0].MaxValue = double.NaN;
                barChart.XAxes[0].MinValue = double.NaN;
                barChart.YAxes[0].MaxValue = double.NaN;
                barChart.YAxes[0].MinValue = double.NaN;
                barChart.XAxes[0].Interval = 20;
                barChart.YAxes[0].MinValue = 0;
                barChart.YAxes[0].MaxValue = 120;
                barChart.YAxes[0].Interval = 20;
                barChart.PlotAreaStrokeThickness = new Thickness(0, 0, 0, 2);




				////LineChart
				//lineChart.GridType = GridType.Vertical;
				//lineChart.Behavior = Behavior.AllowXDrag;
				//lineChart.XAxisSettings.LabelType = LabelType.AutoScale;
				//lineChart.XLabels = new List<string>();
				//lineChart.XAxisSettings.MinValue = 0;
				//lineChart.XAxisSettings.MaxValue = 40;
				//lineChart.XAxisSettings.Interval = 10;

				//lineChart.YAxisSettings.LabelType = LabelType.CustomText;
				//lineChart.YLabels = labelsLine;
				//lineChart.YAxisSettings.MinValue = 0;
				//lineChart.YAxisSettings.MaxValue = 11;
				//lineChart.YAxisSettings.Interval = 1;


              
			}
		}

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            barChart.ShowCrosshair = true;
            lineChart.ShowCrosshair = true;
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            barChart.ShowCrosshair = false;
            lineChart.ShowCrosshair = false;
        }
	}
}
