﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Effects;

namespace Demo
{
	/// <summary>
	/// Interaction logic for PieTypes.xaml
	/// </summary>
	public partial class PieTypes : UserControl
	{
		SalesList sales;

		public PieTypes()
		{
			InitializeComponent();
			
			pieChart1.Title = "";
			 sales = new SalesList();
            pieChart1.DataSource = sales;
            //pieChart1.PlotAreaMargin = new Thickness(40, 20, 40, 20);

            PieSeries series = new PieSeries();
            pieChart1.Series.Add(series);
            series.Effect = new DropShadowEffect() { Opacity = 0.3, ShadowDepth = 3, };
            series.Effect.Freeze();

			series.OuterLabelType = LabelType.CustomText;
			series.OuterLabelOffset = 25;
			series.OuterLabelPath = "Month";
			series.DataPath = "Profit";

            series.DetachedSlicesList = new DoubleCollection() { 0, 0, 0, 0, 0, 0 };
            series.LabelForeground = Brushes.White;
			series.LabelFontFamily = new FontFamily("Arial");
            series.OuterLabelOffset = 40;
			pieChart1.TitleFontFamily = new FontFamily("Arial");
			pieChart1.HorizontalContentAlignment = HorizontalAlignment.Center;
			pieChart1.VerticalContentAlignment = VerticalAlignment.Center;
            pieChart1.PlotAreaMargin = new Thickness(90,0,90,0);

		
            BrushCollection col = Utilities.GetGradientFills();;
            for (int i = 0; i < col.Count; i++)
            {
                LinearGradientBrush b = col[i] as LinearGradientBrush;
                Color light = b.GradientStops[0].Color;
                Color dark = b.GradientStops[1].Color;
                VisualBrush brush = Utilities.CreateVisualBrush(
                    dark, light, new SolidColorBrush(dark), 0, Orientation.Horizontal, 0);

                series.Fills.Add(brush);
                series.Strokes.Add(new SolidColorBrush(dark));
                series.StrokeThickness = 4;
            }


			//series.Fills = Utilities.GetGradientStrokes();
            //series.Strokes = Utilities.GetGradientStrokes();	
		}

		private void OnSliceIndexChecked(object sender, RoutedEventArgs e)
		{
			SetDetachedSlicesList();
		}

		private void OnSliceIndexUnchecked(object sender, RoutedEventArgs e)
		{
			SetDetachedSlicesList();
		}

		private void OnDoughnutChecked(object sender, RoutedEventArgs e)
		{
			if (pieChart1 != null)
			{
				PieSeries series = pieChart1.Series[0] as PieSeries;
				series.PieType = PieType.Doughnut2D;
				pieChart1.UpdateChart();
			}
		}

		private void OnDoughnutUnchecked(object sender, RoutedEventArgs e)
		{
			if (pieChart1 != null)
			{
				PieSeries series = pieChart1.Series[0] as PieSeries;
				series.PieType = PieType.Pie2D;
				pieChart1.UpdateChart();
			}
		}

		private void SetDetachedSlicesList()
		{
            PieSeries series = pieChart1.Series[0] as PieSeries;
            DoubleCollection d = series.DetachedSlicesList;
         
			if (sliceIndex1.IsChecked == true)
				d[0] = slider.Value;
			if (sliceIndex2.IsChecked == true)
				d[1] = slider.Value;
			if (sliceIndex3.IsChecked == true)
				d[2] = slider.Value;
			if (sliceIndex4.IsChecked == true)
				d[3] = slider.Value;
			if (sliceIndex5.IsChecked == true)
				d[4] = slider.Value;
			if (sliceIndex6.IsChecked == true)
				d[5] = slider.Value;			
		}

		private void Slider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			if (pieChart1 != null)
				SetDetachedSlicesList();
		}

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }

        private void ComboBox_DropDownOpened(object sender, EventArgs e)
        {
            ((sender as ComboBox).Items[0] as ComboBoxItem).Visibility = Visibility.Collapsed;
        }

        private void ComboBox_DropDownClosed(object sender, EventArgs e)
        {
            ((sender as ComboBox).Items[0] as ComboBoxItem).Visibility = Visibility.Visible;
        }
	}
}
