﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Media3D;
using System.Windows.Media.Effects;

namespace Demo
{
	/// <summary>
	/// Interaction logic for PieTypes3D.xaml
	/// </summary>
	public partial class PieTypes3D : UserControl
	{
		private SalesList sales;
		private PieSeries seriestSmall;
		private PieSeries seriesBig;

		public PieTypes3D()
		{
			InitializeComponent();

			pieChart3D1.BeginInit();

			pieChart3D1.TitleVisibility = Visibility.Collapsed;

            System.Windows.Controls.Grid.SetZIndex(pieChart3D1, -1);

			sales = new SalesList();
			pieChart3D1.DataSource = sales;
			pieChart3D1.Scale = 150;
			pieChart3D1.StartAngle = 180;
            pieChart3D1.RotationAxis = new Vector3D(pieChart3D1.RotationAxis.X - 2, pieChart3D1.RotationAxis.Y - 1, pieChart3D1.RotationAxis.Z - 1);
            //pieChart3D1.RenderBackSides = true;
            pieChart3D1.Series.Clear();
			for (int i = 0; i < 2; i++)
			{
				PieSeries series = new PieSeries();
				series.OuterLabelOffset = 15;				
				series.OuterLabelPath = "Month";
				series.DataPath = "Profit";
				series.InnerLabelPath = "Month";
				series.DataPath = "Turnover";
				series.DetachedSlicesList = new DoubleCollection() { 0, 0, 0, 0, 0, 0 };
				series.LabelFontFamily = new FontFamily("Arial");
                series.LabelForeground = Brushes.White;
                series.LabelFontSize = 11;
                
                //Brush bc = Utilities.GetGradientFills(false, (byte)(255))[3];
                //bc = TransformBrush(bc, 100);

                //series.LabelBorderBrush = Utilities.GetGradientStrokes()[3];
                //series.LabelBorderThickness = new Thickness(1);
                //series.LabelBackground = bc;
			
				if (i == 0)
				{
                    for (int j = 0; j < 6; j++)
                    {
                        Brush b = Utilities.GetGradientFills(false, (byte)(255))[7];                       
                        series.Fills.Add(b);
                    }				
					series.OuterLabelType = LabelType.Empty;
					seriestSmall = series;
                    series.LabelForeground = Brushes.White;                
				}
				else
				{
                    for (int j = 0; j < 6; j++)
                    {
                        Brush b = Utilities.GetGradientFills(false, (byte)(255))[3];
                        series.Fills.Add(b);
                    }	
					series.OuterLabelType = LabelType.ChartData;
					seriesBig = series;
                    series.LabelForeground = Brushes.White;           
				}
				pieChart3D1.Series.Add(series);
			}

			pieChart3D1.TitleFontFamily = new FontFamily("Arial");
			pieChart3D1.HorizontalContentAlignment = HorizontalAlignment.Center;
			pieChart3D1.VerticalContentAlignment = VerticalAlignment.Center;
			pieChart3D1.DoughnutThickness = 2.5;

			pieChart3D1.EndInit();  
		}

        private VisualBrush TransformBrush(Brush transBrush, double opacity)
        {
            LinearGradientBrush b = transBrush as LinearGradientBrush;
            Color light = b.GradientStops[0].Color;
            Color dark = b.GradientStops[1].Color;
            VisualBrush brush = Utilities.CreateVisualBrush(
                dark, light, new SolidColorBrush(dark), 0, Orientation.Horizontal, 0);
            brush.Opacity = opacity;
            return brush;
        }

		private void OnSliceIndexChecked(object sender, RoutedEventArgs e)
		{
			SetDetachedSlicesList();
		}

		private void OnSliceIndexUnchecked(object sender, RoutedEventArgs e)
		{
			SetDetachedSlicesList();
		}

		private void OnDoughnutChecked(object sender, RoutedEventArgs e)
		{
			if (pieChart3D1 != null)
			{
				pieChart3D1.DoughnutThickness = 5;
				//PieSeries series = pieChart3D1.Series[0] as PieSeries;
				//series.PieType = PieType.Doughnut2D;
				//pieChart3D1.UpdateChart();
			}
		}

		private void OnDoughnutUnchecked(object sender, RoutedEventArgs e)
		{
			if (pieChart3D1 != null)
			{
				pieChart3D1.DoughnutThickness = 0;
				//PieSeries series = pieChart3D1.Series[0] as PieSeries;
				//series.PieType = PieType.Pie2D;
				//pieChart3D1.UpdateChart();
			}
		}

		private void SetDetachedSlicesList()
		{
            DoubleCollection d = new DoubleCollection() { 0, 0, 0, 0, 0, 0 };
			if (sliceIndex1.IsChecked == true)
				d[0] = slider.Value;
			if (sliceIndex2.IsChecked == true)
				d[1] = slider.Value;
			if (sliceIndex3.IsChecked == true)
				d[2] = slider.Value;
			if (sliceIndex4.IsChecked == true)
				d[3] = slider.Value;
			if (sliceIndex5.IsChecked == true)
				d[4] = slider.Value;
			if (sliceIndex6.IsChecked == true)
				d[5] = slider.Value;

			seriesBig.DetachedSlicesList = d;
		}

		private void Slider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			if (pieChart3D1 != null)
				SetDetachedSlicesList();
		}

		private void cornerSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
            if (pieChart3D1 == null)
                return;
            double d = pieChart3D1.ModelHeight;
            if (double.IsNaN(d))
                d = 10;
			pieChart3D1.CornerRadius3D = cornerSlider.Value * (d / 2);
		}

		private void squireSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
            pieChart3D1.MeshFaceSize = squireSlider.Value * 5 + 0.5;
		}

		private void DoughnutSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
            if (pieChart3D1 == null)
                return;
            double d = Math.Max(pieChart3D1.ModelWidth, pieChart3D1.ModelDepth);
            if (double.IsNaN(d))
                d = 60;
            pieChart3D1.DoughnutThickness = DoughnutSlider.Value * (d / 2);
		}

		private void innerLabelBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			if (pieChart3D1 == null)
				return;
			
            //if (innerLabelBox.SelectedIndex == 0)
            //    seriesBig.InnerLabelType = LabelType.ChartData;			
            //if (innerLabelBox.SelectedIndex == 1)
            //    seriesBig.InnerLabelType = LabelType.Percents;
            //if (innerLabelBox.SelectedIndex == 2)
            //    seriesBig.InnerLabelType = LabelType.Empty;
		}

		private void outerLabelBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			if (pieChart3D1 == null)
				return;
			
            //if (outerLabelBox.SelectedIndex == 0)
            //    seriesBig.OuterLabelType = LabelType.ChartData;			
            //if (outerLabelBox.SelectedIndex == 1)
            //    seriesBig.OuterLabelType = LabelType.Percents;
            //if (outerLabelBox.SelectedIndex == 2)
            //    seriesBig.OuterLabelType = LabelType.Empty;
		}

		private void innerLabelSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			if (pieChart3D1 == null)
				return;
			//seriesBig.InnerLabelLocation = innerLabelSlider.Value;
		}

		private void outerLabelSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			if (pieChart3D1 == null)
				return;
			//seriesBig.OuterLabelOffset = outerLabelSlider.Value * 50;
		}

		private void CheckBox_Checked(object sender, RoutedEventArgs e)
		{
			pieChart3D1.SliceLayout = SliceLayout.Cascading;
			pieChart3D1.ModelHeight = 30;
		}

		private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
		{
			pieChart3D1.SliceLayout = SliceLayout.Flat;
			pieChart3D1.ModelHeight = 10;
		}

		private void orBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			if (pieChart3D1 == null)
				return;

			if (orBox.SelectedIndex == 0)
				pieChart3D1.DetachOrientation = Orientation.Horizontal;
			if (orBox.SelectedIndex == 1)
				pieChart3D1.DetachOrientation = Orientation.Vertical;
		}

		private void CheckBox_Checked_1(object sender, RoutedEventArgs e)
		{
			pieChart3D1.Series.Remove(seriestSmall);
		}

		private void CheckBox_Unchecked_1(object sender, RoutedEventArgs e)
		{
			pieChart3D1.Series.Insert(0, seriestSmall);
		}

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }

        private void ComboBox_DropDownOpened(object sender, EventArgs e)
        {
            ((sender as ComboBox).Items[0] as ComboBoxItem).Visibility = Visibility.Collapsed;
           
        }

        private void ComboBox_DropDownClosed(object sender, EventArgs e)
        {
            ((sender as ComboBox).Items[0] as ComboBoxItem).Visibility = Visibility.Visible;
         
        }
	}
}
