﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Effects;
using Microsoft.Win32;
using System.IO;
using System.Diagnostics;

namespace Demo
{
    /// <summary>
    /// Interaction logic for Themes.xaml
    /// </summary>
    public partial class Themes : UserControl
    {
        BrushCollection brushes = Utilities.GetGradientStrokes();
        BrushCollection strokes = Utilities.GetGradientFills();

        public Themes()
        {
            InitializeComponent();

            //DropShadowEffect effect = null;// new DropShadowEffect() { Opacity = 0.5, ShadowDepth = 3, };
            DropShadowEffect effect = new DropShadowEffect() { Opacity = 0.5, ShadowDepth = 3, };
           

            barChart.BeginInit();
            lineChart.BeginInit();
            pieChart.BeginInit();
            radarChart.BeginInit();


            //BarChart
            BarSeries barSerie = new BarSeries();
            barChart.Series.Add(barSerie);
            barSerie.InnerLabelType = LabelType.Empty;
            barSerie.Effect = effect;
            barSerie.TopLabelType = LabelType.Percents;
            barSerie.XData = new DoubleCollection() { 1, 2, 3, 4, 5, 6, 7, 8 };
            barSerie.YData = new DoubleCollection() { 28, 42, 17, 82, 33, 76, 39, 54 };


            barChart.YAxes[0].LabelFontSize = 12;
            barChart.YAxes[0].TitleFontSize = 12;
            barChart.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;
            barChart.YAxes[0].LabelFormat = "0.##";
            barChart.YAxes[0].LabelFontFamily = new FontFamily("Times New Roman");
            barChart.YAxes[0].TitleFontFamily = new FontFamily("Times New Roman");
            barChart.YAxes[0].Tick = 3;

            barChart.XAxes[0].LabelFontSize = 12;
            barChart.XAxes[0].TitleFontSize = 12;
            barChart.XAxes[0].LabelType = LabelType.CustomText;
            barChart.XAxes[0].HorLabelAlignment = HorizontalAlignment.Center;
            barChart.XAxes[0].LabelFormat = "0.##";
            barChart.XAxes[0].LabelFontFamily = new FontFamily("Times New Roman");
            barChart.XAxes[0].TitleFontFamily = new FontFamily("Times New Roman");
            barChart.XAxes[0].Tick = 3;        

            barChart.XAxes[0].Labels = new string[] { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug" };
            barChart.TitleFontSize = 14;
            barChart.TitleMargin = new Thickness(0,15,0,0);
            barChart.TitleFontFamily = new FontFamily("Times New Roman");
            barChart.FontFamily = new FontFamily("Times New Roman");





            //LineChart
            LineSeries lineSerie1 = new LineSeries();                     
            lineSerie1.Effect = effect;    
            lineSerie1.ScatterType = ScatterType.Square;
            lineSerie1.ScatterSize = 11;
            lineChart.LineType = LineType.Area2D;
            lineSerie1.XData = new DoubleCollection() { 0.5, 1.5, 2.5, 3.5, 4.5, 5.5, 6.5, 7.5 };
            //double s = 00;
            //lineSerie1.YData = new DoubleCollection() { 28 + s, 42 + s, 17 + s, 62 + s, 33 + s, 18 + s, 61 + s, 55 + s };
            //lineSerie1.YData = new DoubleCollection() { 28, 42, 17, 82, 33, 76, 39, 54 };
            lineSerie1.YData = new DoubleCollection() { 28, 42, 17, 82, 33, 76, 39, 54 };
            lineSerie1.Labels = lineSerie1.YData.ToArray();
            lineChart.Series.Add(lineSerie1);

            //LineSeries lineSerie2 = new LineSeries();
            //lineChart.Series.Add(lineSerie2);
            //lineSerie2.Effect = effect;
            //lineSerie2.ScatterType = ScatterType.Square;
            //lineSerie2.ScatterSize = 11;
            //lineSerie2.LineType = LineType.Area2D;
            //lineSerie2.XData = new DoubleCollection() { 0.5, 1.5, 2.5, 3.5, 4.5, 5.5, 6.5, 7.5 };
            //double s2 = 5;
            //lineSerie2.YData = new DoubleCollection() { 23 - s2, 18 - s2, 74 - s2, 58 - s2, 28 - s2, 12 - s2, 17 - s2, 49 - s2 };
            //lineSerie2.Labels = lineSerie2.YData.ToArray();


            lineChart.YAxes[0].LabelFontSize = 12;
            lineChart.YAxes[0].TitleFontSize = 12;
            lineChart.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;
            lineChart.YAxes[0].LabelFormat = "0.##";
            lineChart.YAxes[0].LabelFontFamily = new FontFamily("Times New Roman");
            lineChart.YAxes[0].TitleFontFamily = new FontFamily("Times New Roman");
            lineChart.YAxes[0].Tick = 3;        

            lineChart.XAxes[0].LabelFontSize = 12;
            lineChart.XAxes[0].TitleFontSize = 12;
            lineChart.XAxes[0].LabelType = LabelType.CustomText;
            lineChart.XAxes[0].HorLabelAlignment = HorizontalAlignment.Center;
            lineChart.XAxes[0].LabelFormat = "0.##";
            lineChart.XAxes[0].MaxValue = 8;
            lineChart.XAxes[0].LabelFontFamily = new FontFamily("Times New Roman");
            lineChart.XAxes[0].TitleFontFamily = new FontFamily("Times New Roman");
            lineChart.XAxes[0].Tick = 3;    

            lineChart.XAxes[0].Labels = new string[] { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug" };
            lineChart.TitleFontSize = 14;
            lineChart.TitleMargin = new Thickness(0, 15, 0, 0);
            lineChart.TitleFontFamily = new FontFamily("Times New Roman");
            lineChart.FontFamily = new FontFamily("Times New Roman");
           
         




            //PieChart
            PieSeries pieSerie = new PieSeries();           
            pieSerie.Data = new DoubleCollection() { 28, 42, 27, 82, 33, 76, 39, 54 };
            pieSerie.Effect = effect;       
            pieSerie.InnerLabelLocation = 0.4;
            pieSerie.InnerLabelType = LabelType.Percents;
            pieSerie.OuterLabelType = LabelType.ChartData;
            pieSerie.LabelFontSize = 12;
            pieSerie.DetachedSlicesList = new DoubleCollection() { 0, 00, 0, 0, 0, 0, 0, 50 };
            pieSerie.LabelFontFamily = new FontFamily("Times New Roman");
            pieChart.Series.Add(pieSerie);

            pieChart.PlotAreaMargin = new Thickness(40, 10, 40, 10);
            pieChart.TitleMargin = new Thickness(0, 15, 0, 0);
            pieChart.TitleFontFamily = new FontFamily("Times New Roman");
            pieChart.FontFamily = new FontFamily("Times New Roman");




            ////RadarChar
            //RadarSeries radarSerie = new RadarSeries();           
            //radarSerie.LabelFontSize = 12;
            //radarSerie.Data = new DoubleCollection() { 65, 42, 37, 30, 53, 76, 39, 54 ,60 };
            //radarSerie.LabelFontFamily = new FontFamily("Times New Roman");
            //radarSerie.Effect = effect;
            //radarChart.Series.Add(radarSerie);

            //radarChart.FontSize = 12;           
            //radarSerie.ScatterSize = 12;
            //radarChart.InnerLabelAngle = 180;
            //radarChart.TitleMargin = new Thickness(0, 15, 0, 0);
            //radarChart.TitleFontFamily = new FontFamily("Times New Roman");
            //radarChart.FontFamily = new FontFamily("Times New Roman");



            //RadarChar
            RadarSeries radarSerie = new RadarSeries();
            radarSerie.LabelFontSize = 12;
            //radarSerie.Data = new DoubleCollection() { 65, 42, 67, 70, 53, 66, 39, 54, 60, 50 };
            radarSerie.Data = new DoubleCollection() { 3.2, 2.1, 3.4, 3.5, 2.6, 3.3, 1.9, 2.7, 3.0, 2.5 };
            radarSerie.Effect = effect;
            radarSerie.ScatterSize = 15;
            radarChart.Series.Add(radarSerie);

            radarChart.FontSize = 12;
            radarChart.InnerLabelAngle = 90;
            radarChart.MaxValue = 5;
            radarChart.Interval = 1;
            radarChart.TitleMargin = new Thickness(0, 15, 0, 0);
            //radarChart.InnerLabels = new string[] { "0", "1", "2", "3", "4", "5" };
            //radarChart.InnerLabelType = LabelType.CustomText;


            barChart.ChartEffect = ChartEffect.Glass;
            lineChart.ChartEffect = ChartEffect.Glass;
            pieChart.ChartEffect = ChartEffect.Glass;
            radarChart.ChartEffect = ChartEffect.Glass;

            barChart.EndInit();
            lineChart.EndInit();
            pieChart.EndInit();
            radarChart.EndInit();


            barChart.MouseDown += new MouseButtonEventHandler(OnChartMouseDown);
            lineChart.MouseDown += new MouseButtonEventHandler(OnChartMouseDown);
            pieChart.MouseDown += new MouseButtonEventHandler(OnChartMouseDown);
            radarChart.MouseDown += new MouseButtonEventHandler(OnChartMouseDown);
        }

        void OnChartMouseDown(object sender, MouseButtonEventArgs e)
        {
            if (e.LeftButton == MouseButtonState.Pressed && 
                e.RightButton == MouseButtonState.Released)
            {

            }
            else if (e.RightButton == MouseButtonState.Pressed &&
                e.LeftButton == MouseButtonState.Released)
            {

            }
        }

        private void cbThemes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ChartTheme theme = new ChartTheme();
            //string folder = System.IO.Path.GetDirectoryName(Process.GetCurrentProcess().MainModule.FileName);// +@"\Debug\";
            //string filter = "*.xml";
            //string[] files = Directory.GetFiles(folder, filter);

            List<string> list = new List<string>();
            //for (int i = 0; i < files.Length; i++)
            //{
            //    if (files[i].EndsWith("Blue.xml") ||
            //        files[i].EndsWith("Green.xml") ||
            //        files[i].EndsWith("Gold.xml") ||
            //        files[i].EndsWith("Vista.xml") ||
            //        files[i].EndsWith("Sand.xml") ||
            //        files[i].EndsWith("MultiColor.xml"))
            //        list.Add(files[i]);
            //}

            string[] names = new string[] { "Blue", "Green", "Gold", "Vista", "Sand", "MultiColor"};
            foreach (string name in names)
            {
                string result = FindTheme(name + ".xml");

                if (result != null)
                    list.Add(result);
            }

            if (barChart != null)
            {
                if (cbThemes.SelectedIndex == 0)
                {
                    MindFusion.Charting.Wpf.BarChart fakeChart = new MindFusion.Charting.Wpf.BarChart();
                    fakeChart.Series.Add(new BarSeries());                    
                    ChartTheme emptyTheme = new ChartTheme(fakeChart);
                    emptyTheme.Apply(barChart);
                    emptyTheme.Apply(lineChart);
                    emptyTheme.Apply(pieChart);
                    emptyTheme.Apply(radarChart);
                }
                else
                {
                    barChart.LoadTheme(list[cbThemes.SelectedIndex - 1]);
                    lineChart.LoadTheme(list[cbThemes.SelectedIndex - 1]);
                    pieChart.LoadTheme(list[cbThemes.SelectedIndex - 1]);
                    radarChart.LoadTheme(list[cbThemes.SelectedIndex - 1]);
                }
            }
        }

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }

        private void cbChart_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (barChart == null)
                return;

            if (cbChart.SelectedIndex == 0)
            {
                System.Windows.Controls.Grid.SetColumn(barChart, 0);
                System.Windows.Controls.Grid.SetRow(barChart, 0);
                System.Windows.Controls.Grid.SetColumnSpan(barChart, 2);
                System.Windows.Controls.Grid.SetRowSpan(barChart, 2);
                barChart.Margin = new Thickness(0);

                barChart.Visibility = Visibility.Visible;
                lineChart.Visibility = Visibility.Hidden;
                pieChart.Visibility = Visibility.Hidden;
                radarChart.Visibility = Visibility.Hidden;
            }
            if (cbChart.SelectedIndex == 1)
            {
                System.Windows.Controls.Grid.SetColumn(lineChart, 0);
                System.Windows.Controls.Grid.SetRow(lineChart, 0);
                System.Windows.Controls.Grid.SetColumnSpan(lineChart, 2);
                System.Windows.Controls.Grid.SetRowSpan(lineChart, 2);
                lineChart.Margin = new Thickness(0);

                barChart.Visibility = Visibility.Hidden;
                lineChart.Visibility = Visibility.Visible;
                pieChart.Visibility = Visibility.Hidden;
                radarChart.Visibility = Visibility.Hidden;
            }
            if (cbChart.SelectedIndex == 2)
            {
                System.Windows.Controls.Grid.SetColumn(pieChart, 0);
                System.Windows.Controls.Grid.SetRow(pieChart, 0);
                System.Windows.Controls.Grid.SetColumnSpan(pieChart, 2);
                System.Windows.Controls.Grid.SetRowSpan(pieChart, 2);
                pieChart.Margin = new Thickness(0);

                barChart.Visibility = Visibility.Hidden;
                lineChart.Visibility = Visibility.Hidden;
                pieChart.Visibility = Visibility.Visible;
                radarChart.Visibility = Visibility.Hidden;
            }
            if (cbChart.SelectedIndex == 3)
            {
                System.Windows.Controls.Grid.SetColumn(radarChart, 0);
                System.Windows.Controls.Grid.SetRow(radarChart, 0);
                System.Windows.Controls.Grid.SetColumnSpan(radarChart, 2);
                System.Windows.Controls.Grid.SetRowSpan(radarChart, 2);
                radarChart.Margin = new Thickness(0);

                barChart.Visibility = Visibility.Hidden;
                lineChart.Visibility = Visibility.Hidden;
                pieChart.Visibility = Visibility.Hidden;
                radarChart.Visibility = Visibility.Visible;
            }
            if (cbChart.SelectedIndex == 4)
            {


                System.Windows.Controls.Grid.SetColumn(barChart, 0);
                System.Windows.Controls.Grid.SetRow(barChart, 0);
                System.Windows.Controls.Grid.SetColumnSpan(barChart, 1);
                System.Windows.Controls.Grid.SetRowSpan(barChart, 1);

                System.Windows.Controls.Grid.SetColumn(lineChart, 0);
                System.Windows.Controls.Grid.SetRow(lineChart, 1);
                System.Windows.Controls.Grid.SetColumnSpan(lineChart, 1);
                System.Windows.Controls.Grid.SetRowSpan(lineChart, 1);

                System.Windows.Controls.Grid.SetColumn(pieChart, 1);
                System.Windows.Controls.Grid.SetRow(pieChart, 0);
                System.Windows.Controls.Grid.SetColumnSpan(pieChart, 1);
                System.Windows.Controls.Grid.SetRowSpan(pieChart, 1);

                System.Windows.Controls.Grid.SetColumn(radarChart, 1);
                System.Windows.Controls.Grid.SetRow(radarChart, 1);
                System.Windows.Controls.Grid.SetColumnSpan(radarChart, 1);
                System.Windows.Controls.Grid.SetRowSpan(radarChart, 1);



                barChart.Visibility = Visibility.Visible;
                lineChart.Visibility = Visibility.Visible;
                pieChart.Visibility = Visibility.Visible;
                radarChart.Visibility = Visibility.Visible;
                barChart.Margin = new Thickness(0, 0, -1, -1);
                lineChart.Margin = new Thickness(0, 0, -1, 0);
                pieChart.Margin = new Thickness(0, 0, 0, -1);
                radarChart.Margin = new Thickness(0, 0, 0, 0);
            }
        }

        private void Grid_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            double width = e.NewSize.Width;
            double heigth = e.NewSize.Height;
            for (int i = 0; i < 2; i++)
            {
                chartGrid.RowDefinitions[0].Height = new GridLength(Math.Round(heigth / 2));
            }
        }

        private void cbChartEffect_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (barChart == null)
                return;

            if (cbChartEffect.SelectedIndex == 0)
            {
                barChart.ChartEffect = ChartEffect.Glass;
                lineChart.ChartEffect = ChartEffect.Glass;
                pieChart.ChartEffect = ChartEffect.Glass;
                radarChart.ChartEffect = ChartEffect.Glass;
            }
            else
            {
                barChart.ChartEffect = ChartEffect.None;
                lineChart.ChartEffect = ChartEffect.None;
                pieChart.ChartEffect = ChartEffect.None;
                radarChart.ChartEffect = ChartEffect.None;
            }
        }

        private string FindFolder(string folderName)
        {
            string testDir = @"..\Themes\";
            for (int i = 0; i < 10; i++)
            {
                if (Directory.Exists(testDir))
                    break;
                testDir = @"..\" + testDir;
            }

            var testFolder = testDir + folderName;
            if (Directory.Exists(testDir))
                return testDir;

            return "";
        }

        private string FindTheme(string fileName)
        {
            string folder = FindFolder(@"Themes\");

            var testFile = folder + fileName;
            if (File.Exists(testFile))
                return testFile;
            
            return null;
        }
    }
}
