﻿using System;
using System.Globalization;
using System.Reflection;
using System.Windows.Data;
using System.Windows.Markup;
using System.Xml;

namespace Demo
{
    /// <summary>
    /// Creates a complete Uri for each example. This is used in conjunction with the schema of
    /// BookMeta.xml
    /// </summary>
    public class UriConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null)
            {
                return null;
            }

            XmlNode elt = value as XmlNode;

            string uri = null;

			if (elt.Name == "MenuItem" || elt.Name == "SubMenuItem")
			{
				XmlAttribute attribute = elt.Attributes["File"];
				if (attribute != null)
					uri = attribute.Value;
			}
          
            return uri;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new System.NotImplementedException();
        }
    }
}