﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Windows;
using MindFusion.Charting.Wpf;
using System.Windows.Controls;
using System.Windows.Shapes;

namespace Demo
{
	public class Utilities
	{
        public static BrushCollection GetGradientFills()
		{
			return GetGradientFills(false);
		}

        public static BrushCollection GetGradientFills(bool vertical)
		{
			return GetGradientFills(vertical, 255);
		}

        public static BrushCollection GetGradientFills(bool vertical, byte transparency)
		{
            BrushCollection list = new BrushCollection();
			for (int i = 0; i < 8; i++)
			{
				LinearGradientBrush brush = new LinearGradientBrush();
				
				brush.StartPoint = new Point(0, 0);
				if (vertical)
					brush.EndPoint = new Point(0, 1);
				else
					brush.EndPoint = new Point(1, 0);
				Color startColor = new Color();
				Color endColor = new Color();
				if (i == 0)
				{
					startColor = Color.FromArgb(transparency, 189, 252, 189);
					endColor = Color.FromArgb(transparency, 145, 191, 141);
				}
				if (i == 1)
				{
					startColor = Color.FromArgb(transparency, 255, 222, 190);
					endColor = Color.FromArgb(transparency, 255, 194, 132);
				}
				if (i == 2)
				{
					startColor = Color.FromArgb(transparency, 188, 189, 250);
					endColor = Color.FromArgb(transparency, 116, 131, 149);
				}
				if (i == 3)
				{
					startColor = Color.FromArgb(transparency, 235, 181, 235);
					endColor = Color.FromArgb(transparency, 194, 6, 194);
				}
				if (i == 4)
				{
					startColor = Color.FromArgb(transparency, 245, 244, 218);
					endColor = Color.FromArgb(transparency, 238, 233, 173);
				}
				if (i == 5)
				{
					startColor = Color.FromArgb(transparency, 171, 234, 234);
					endColor = Color.FromArgb(transparency, 98, 161, 163);
				}
				if (i == 6)
				{
					startColor = Color.FromArgb(transparency, 252, 214, 165);
					endColor = Color.FromArgb(transparency, 172, 134, 85);
				}
				if (i == 7)
				{
					startColor = Color.FromArgb(transparency, 91, 232, 255);
					endColor = Color.FromArgb(transparency, 91, 144, 255);
				}
				brush.GradientStops.Add(new GradientStop(startColor, 0.0));
				brush.GradientStops.Add(new GradientStop(endColor, 1.0));
				list.Add(brush);
			}

			return list;
		}

        public static BrushCollection GetGradientStrokes()
		{
			return GetGradientStrokes(255);
		}

        public static BrushCollection GetGradientStrokes(byte transparency)
		{
            BrushCollection list = new BrushCollection();
			for (int i = 0; i < 8; i++)
			{
				SolidColorBrush brush = null;

				if (i == 0)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 95, 141, 91));
				if (i == 1)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 205, 144, 82));
				if (i == 2)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 66, 81, 99));
				if (i == 3)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 144, 1, 144));
				if (i == 4)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 188, 183, 123));
				if (i == 5)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 48, 111, 113));
				if (i == 6)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 122, 84, 35));
				if (i == 7)
					brush = new SolidColorBrush(Color.FromArgb(transparency, 41, 94, 205));

				list.Add(brush);
			}

			return list;
		}

        public static BrushCollection GetFills()
		{
            BrushCollection brushList = new BrushCollection() { 
			    new SolidColorBrush(Color.FromArgb(255,223,115,102)),
			    new SolidColorBrush(Color.FromArgb(255,170,164,98)),
			    new SolidColorBrush(Color.FromArgb(255,197,175,197)),
			    new SolidColorBrush(Color.FromArgb(255,169,191,213)),
			    new SolidColorBrush(Color.FromArgb(255,133,173,130)),
			    new SolidColorBrush(Color.FromArgb(255,107,120,134)),
			    new SolidColorBrush(Color.FromArgb(255,213,204,125)),
			    new SolidColorBrush(Color.FromArgb(255,218,147,86)),
			};

			return brushList;
		}

        public static BrushCollection GetStrokes()//da9356
		{
            BrushCollection strokeList = new BrushCollection() { 
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			    new SolidColorBrush(Color.FromArgb(255,50,50,50)),
			};

			return strokeList;
		}

        public static VisualBrush CreateVisualBrush(Color darkColor, Color lightColor,
           Brush borderBrush, double borderThickness, Orientation orientation, double shadowSize)
        {
            return CreateVisualBrush(darkColor, lightColor, borderBrush, borderThickness, orientation, shadowSize, borderThickness);
        }


        public static VisualBrush CreateVisualBrush(Color darkColor, Color lightColor,
            Brush borderBrush, double borderThickness, Orientation orientation, double shadowSize, double cornerRadius)
        {
            VisualBrush visualBrush = new VisualBrush();
            if (orientation == Orientation.Vertical)
            {
                System.Windows.Controls.Grid grid = new System.Windows.Controls.Grid();
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(borderThickness) });
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(shadowSize) });
                grid.ColumnDefinitions.Add(new ColumnDefinition() { MaxWidth = 50});
                grid.ColumnDefinitions.Add(new ColumnDefinition());
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(shadowSize) });
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(borderThickness) });

                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(borderThickness) });
                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(shadowSize) });                
                grid.RowDefinitions.Add(new RowDefinition() { });
                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(shadowSize) });
                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(borderThickness) });



                //Stroke
                Border strokeBorder = new Border();
                strokeBorder.CornerRadius = new CornerRadius(cornerRadius);
                strokeBorder.Background = borderBrush;
                strokeBorder.BorderThickness = new Thickness(0);
                System.Windows.Controls.Grid.SetRowSpan(strokeBorder, 5);
                System.Windows.Controls.Grid.SetColumnSpan(strokeBorder, 6);
                grid.Children.Add(strokeBorder);


                //Fill
                Border fillBorder = new Border();
                fillBorder.CornerRadius = new CornerRadius(cornerRadius);
                System.Windows.Controls.Grid.SetColumn(fillBorder, 1);
                System.Windows.Controls.Grid.SetRow(fillBorder, 1);
                System.Windows.Controls.Grid.SetRowSpan(fillBorder, 3);
                System.Windows.Controls.Grid.SetColumnSpan(fillBorder, 4);
                fillBorder.BorderThickness = new Thickness(0);
                fillBorder.Background = Utilities.GetRadialGradientBrush(1.2, 1.2, new Point(1, 0.5), new Point(1, 0.5),
                    new Color[] { lightColor, darkColor }, new double[] { 0.2, 0.5 });
                grid.Children.Add(fillBorder);




                //Top
                for (int i = 0; i < 4; i++)
                {
                    Border shadowBorder = new Border();
                    shadowBorder.CornerRadius = new CornerRadius(cornerRadius);
                    shadowBorder.BorderThickness = new Thickness(0);

                    if (i == 0)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 1);
                        System.Windows.Controls.Grid.SetColumnSpan(shadowBorder, 4);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 1);
                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Vertical,
                            new Color[] { Color.FromArgb(64, 0, 0, 0), Color.FromArgb(0, 0, 0, 0) }, new double[] { 0, 1 });
                    }
                    if (i == 1)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 1);
                        System.Windows.Controls.Grid.SetColumnSpan(shadowBorder, 4);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 3);
                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Vertical,
                           new Color[] { Color.FromArgb(0, 0, 0, 0), Color.FromArgb(64, 0, 0, 0) }, new double[] { 0, 1 });
                    }
                    if (i == 2)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 1);
                        System.Windows.Controls.Grid.SetRowSpan(shadowBorder, 3);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 1);

                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Horizontal,
                            new Color[] { Color.FromArgb(64, 0, 0, 0), Color.FromArgb(0, 0, 0, 0)}, new double[] { 0, 1 });
                    }
                    if (i == 3)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 4);
                        System.Windows.Controls.Grid.SetRowSpan(shadowBorder, 3);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 1);

                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Horizontal,
                           new Color[] { Color.FromArgb(0, 0, 0, 0), Color.FromArgb(64, 0, 0, 0) }, new double[] { 0, 1 });
                    }

                    grid.Children.Add(shadowBorder);
                }



                PathFigure figure = new PathFigure() { StartPoint = new Point(0, 100) };
                figure.Segments.Add(new LineSegment() { Point = new Point(70, 100) });
                figure.Segments.Add(new BezierSegment() { Point1 = new Point(35, 77), Point2 = new Point(20, 33), Point3 = new Point(35, 0) });
                figure.Segments.Add(new LineSegment() { Point = new Point(0, 0) });

                PathGeometry geometry = new PathGeometry();
                geometry.Figures.Add(figure);

                Path path = new Path();
                path.Stretch = Stretch.Fill;
                System.Windows.Controls.Grid.SetColumnSpan(path, 2);
                System.Windows.Controls.Grid.SetRowSpan(path, 3);
                System.Windows.Controls.Grid.SetRow(path, 1);
                System.Windows.Controls.Grid.SetColumn(path, 1);
                path.Fill = Utilities.GetLinearGradientBrush(Orientation.Horizontal,
                    new Color[] { Colors.White, Colors.Transparent }, new double[] { 0, 0.7 });
                path.Data = geometry;
                grid.Children.Add(path);



                visualBrush.Visual = grid;

            }
            else if (orientation == Orientation.Horizontal)
            {
                System.Windows.Controls.Grid grid = new System.Windows.Controls.Grid();
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(borderThickness) });
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(shadowSize) });
                grid.ColumnDefinitions.Add(new ColumnDefinition());
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(shadowSize) });
                grid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(borderThickness) });

                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(borderThickness) });
                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(shadowSize) });
                grid.RowDefinitions.Add(new RowDefinition() { MaxHeight = 50});
                grid.RowDefinitions.Add(new RowDefinition() { });
                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(shadowSize) });
                grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(borderThickness) });


                //Stroke
                Border strokeBorder = new Border();
                strokeBorder.CornerRadius = new CornerRadius(cornerRadius);
                strokeBorder.Background = borderBrush;
                strokeBorder.BorderThickness = new Thickness(0);
                System.Windows.Controls.Grid.SetRowSpan(strokeBorder, 6);
                System.Windows.Controls.Grid.SetColumnSpan(strokeBorder, 5);
                grid.Children.Add(strokeBorder);


                //Fill
                Border fillBorder = new Border();
                fillBorder.CornerRadius = new CornerRadius(cornerRadius);
                System.Windows.Controls.Grid.SetColumn(fillBorder, 1);
                System.Windows.Controls.Grid.SetRow(fillBorder, 1);
                System.Windows.Controls.Grid.SetRowSpan(fillBorder, 4);
                System.Windows.Controls.Grid.SetColumnSpan(fillBorder, 3);
                fillBorder.BorderThickness = new Thickness(0);
                fillBorder.Background = Utilities.GetRadialGradientBrush(1.2, 1.2, new Point(0.5, 1), new Point(0.5, 1),
                    new Color[] { lightColor, darkColor }, new double[] { 0.2, 0.5 });
                grid.Children.Add(fillBorder);


                //Top
                for (int i = 0; i < 4; i++)
                {
                    Border shadowBorder = new Border();
                    shadowBorder.CornerRadius = new CornerRadius(cornerRadius);
                    shadowBorder.BorderThickness = new Thickness(0);

                    if (i == 0)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 1);
                        System.Windows.Controls.Grid.SetColumnSpan(shadowBorder, 3);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 1);
                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Vertical,
                            new Color[] { Color.FromArgb(64, 0, 0, 0), Color.FromArgb(0, 0, 0, 0), }, new double[] { 0, 1 });
                    }
                    if (i == 1)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 1);
                        System.Windows.Controls.Grid.SetColumnSpan(shadowBorder, 3);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 4);
                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Vertical,
                           new Color[] { Color.FromArgb(0, 0, 0, 0), Color.FromArgb(64, 0, 0, 0) }, new double[] { 0, 1 });
                    }
                    if (i == 2)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 1);
                        System.Windows.Controls.Grid.SetRowSpan(shadowBorder, 4);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 1);

                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Horizontal,
                            new Color[] { Color.FromArgb(64, 0, 0, 0), Color.FromArgb(0, 0, 0, 0), }, new double[] { 0, 1 });
                    }
                    if (i == 3)
                    {
                        System.Windows.Controls.Grid.SetColumn(shadowBorder, 3);
                        System.Windows.Controls.Grid.SetRowSpan(shadowBorder, 4);
                        System.Windows.Controls.Grid.SetRow(shadowBorder, 1);

                        shadowBorder.Background = Utilities.GetLinearGradientBrush(Orientation.Horizontal,
                           new Color[] { Color.FromArgb(0, 0, 0, 0), Color.FromArgb(64, 0, 0, 0) }, new double[] { 0, 1 });
                    }

                    grid.Children.Add(shadowBorder);
                }


             

                PathFigure figure = new PathFigure() { StartPoint = new Point(0, 0) };
                figure.Segments.Add(new LineSegment() { Point = new Point(0, 70) });
                figure.Segments.Add(new BezierSegment() { Point1 = new Point(33,35),Point2 = new Point(66,20), Point3 = new Point(100,35)});
                figure.Segments.Add(new LineSegment() { Point = new Point(100, 0) });

                PathGeometry geometry = new PathGeometry();
                geometry.Figures.Add(figure);

                Path path = new Path();
                path.Stretch = Stretch.Fill;
                System.Windows.Controls.Grid.SetColumnSpan(path, 3);
                System.Windows.Controls.Grid.SetRowSpan(path, 2);
                System.Windows.Controls.Grid.SetRow(path, 1);
                System.Windows.Controls.Grid.SetColumn(path, 1);
                path.Fill = Utilities.GetLinearGradientBrush(Orientation.Vertical,
                    new Color[] { Colors.White, Colors.Transparent }, new double[] { 0, 0.7 });
                path.Data = geometry;
                grid.Children.Add(path);

                visualBrush.Visual = grid;
            }


            return visualBrush;
        }

        private static LinearGradientBrush GetLinearGradientBrush(Orientation orientation, Color[] colors, double[] positions)
        {
            LinearGradientBrush brush = new LinearGradientBrush();
            for (int i = 0; i < colors.Length; i++)
            {
                GradientStop stop = new GradientStop(colors[i], positions[i]);
                brush.GradientStops.Add(stop);
            }

            brush.StartPoint = new Point(0, 0);
            if (orientation == Orientation.Horizontal)
                brush.EndPoint = new Point(1, 0);
            else
                brush.EndPoint = new Point(0, 1);

            return brush;
        }

        private static RadialGradientBrush GetRadialGradientBrush(double rX, double rY,
            Point origin, Point center, Color[] colors, double[] positions)
        {
            RadialGradientBrush brush = new RadialGradientBrush();
            for (int i = 0; i < colors.Length; i++)
            {
                GradientStop stop = new GradientStop(colors[i], positions[i]);
                brush.GradientStops.Add(stop);
            }

            brush.GradientOrigin = origin;
            brush.Center = center;
            brush.RadiusX = rX;
            brush.RadiusY = rY;

            return brush;
        }   
	}
}
