﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Effects;

namespace Demo
{
	/// <summary>
	/// Interaction logic for Zoom.xaml
	/// </summary>
	public partial class Zoom : UserControl
	{
		public Zoom()
		{
			InitializeComponent();
            BrushCollection fills = Utilities.GetGradientFills();
            BrushCollection strokes = Utilities.GetGradientStrokes();

	

			//Line Chart		
			lineChart.Behavior = Behavior.ZoomChart;
			lineChart.TitleVisibility = Visibility.Collapsed;
			lineChart.YAxes[0].Title = "";
			lineChart.XAxes[0].Title = "";

			lineChart.XAxes[0].LabelType = LabelType.AutoScale;
            lineChart.XAxes[0].LabelRotationAngle = 90;
            lineChart.XAxes[0].MinValue = 0;
            lineChart.XAxes[0].MaxValue = 30;
            lineChart.XAxes[0].Interval = 1;
            lineChart.XAxes[0].LabelStroke = Brushes.White;
            lineChart.XAxes[0].HorLabelAlignment = HorizontalAlignment.Center;

            lineChart.YAxes[0].LabelType = LabelType.AutoScale;
            lineChart.YAxes[0].MinValue = 0;
            lineChart.YAxes[0].MaxValue = 40;
            lineChart.YAxes[0].Interval = 5;
            lineChart.YAxes[0].LabelStroke = Brushes.White;
            lineChart.YAxes[0].VertLabelAlignment = VerticalAlignment.Center;

			Random r = new Random();
            lineChart.LineType = LineType.Area2D;
			lineChart.Series.Clear();
            LineSeries series = new LineSeries()
            {
                Fills = new BrushCollection(),
                Strokes = new BrushCollection(),
                ScatterStrokes = new BrushCollection(),
                ScatterFills = new BrushCollection(),
            };
            series.Effect = new DropShadowEffect() { Opacity = 0.3, ShadowDepth = 3, };
            //series.Labels = new string[] { "10", "10", "1000", "1999", "1000000", };
            series.Strokes.Add(new SolidColorBrush((fills[7] as LinearGradientBrush).GradientStops[1].Color));
            series.Fills.Add(Window1.TransformBrush(fills[7], 255));
            series.ScatterFills.Add(Window1.TransformBrush(fills[7], 255));
			series.ScatterStrokes.Add(strokes[7]);
			series.ScatterSize = 17;
			series.ScatterType = ScatterType.Circle;
            series.StrokeThickness = 4;
            lineChart.ClipToPlotArea = false;
			for (int j = 0; j < 31; j++)
			{
				double ampl = r.NextDouble() * 4 + 0.1;
				if (r.Next(1, 3) == 1)
					ampl = r.NextDouble() * 25 + 0.1; // Jump
				ampl += 5;

				series.YData.Add(ampl);
				series.XData.Add(j);
			}
			lineChart.Series.Add(series);

            VisualBrush fb1 = Utilities.CreateVisualBrush(
                Colors.Gray, Colors.White, new SolidColorBrush(Colors.Gray), 0, Orientation.Horizontal, 0);
            fb1.Opacity = 0.2;

            lineChart.GridFills.Add(fb1);

            lineChart.AppearanceChanged += new System.ComponentModel.PropertyChangedEventHandler(lineChart_AppearanceChanged);

            lineChart.DataChanged += new EventHandler(lineChart_DataChanged);
            lineChart.DragLeave += new DragEventHandler(lineChart_DragLeave);    
		}

        void lineChart_DragLeave(object sender, DragEventArgs e)
        {
            throw new NotImplementedException();
        }

        void lineChart_DataChanged(object sender, EventArgs e)
        {
            //MessageBox.Show("opa");
        }

        void lineChart_AppearanceChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Zoom")
                MessageBox.Show("opa");
        }

		private void OnResetZoomClick(object sender, RoutedEventArgs e)
		{
			lineChart.ResetZoom();
		}

		private void OnZoomOutClick(object sender, RoutedEventArgs e)
		{
			lineChart.ZoomOut();
		}

        private void Border_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            Window1.OnBackPanelSizeChanged(sender);
        }
	}
}
